<template>
  <div>
    <div class="heatmap" style="position: relative; margin-left: 8px">
      <video :id="'video' + randomId" playsinline webkit-playsinline>
        <source :src="hls_video_url" type="application/x-mpegURL" />
      </video>
      <canvas
        id="canvas"
        style="position: absolute; top: 0; left: 0; pointer-events: none"
      ></canvas>
    </div>
    <div v-if="isShowLineChart" style="height: 60px; width: 100%">
      <apexchart
        type="line"
        height="100"
        :options="chartOptions"
        :series="lineSeries"
        class="line-chart"
      />
    </div>
  </div>
</template>

<script>
import JQuery from 'jquery';
let $ = JQuery;
import fluidPlayer from 'fluid-player';
const importScript = () => {
  if (!window.h337) {
    const script = document.createElement('script');
    script.src =
      'https://cdnjs.cloudflare.com/ajax/libs/heatmap.js/2.0.0/heatmap.min.js';
    const body = document.querySelector('body');
    body.appendChild(script);
  }
};

export default {
  name: 'heatmap-video',
  props: {
    hls_video_url: {
      type: String,
      required: true,
    },
    trackings: {
      type: Array,
      required: true,
    },
    users: {
      type: Array,
      default: () => [],
    },
    isShowUserName: {
      type: Boolean,
      default: () => false,
    },
    isShowLineChart: {
      type: Boolean,
      default: () => false,
    },
  },
  data() {
    return {
      heatmapDatas: [],
      userNames: [],
      chartOptions: {},
      lineSeries: [],
      averageTime: '',
      averageTimeRate: '',
      randomId: Math.floor(Math.random() * 101), // 再生時間の表記がバグるため、videoのidを動画が変わる毎に変更
    };
  },
  mounted() {
    importScript(); // to use heatmap
    fluidPlayer('video' + this.randomId, {
      layoutControls: {
        primaryColor: '#e93a83',
        fillToContainer: true,
        subtitlesEnabled: false,
        allowTheatre: false,
        doubleclickFullscreen: false,
        controlBar: {
          autoHide: false,
          autoHideTimeout: 500,
          animated: true,
        },
      },
    });

    Apex = {
      stroke: {
        curve: 'straight',
        width: 3,
      },
      tooltip: {
        followCursor: false,
        theme: 'dark',
        x: {
          show: false,
        },
        marker: {
          show: false,
        },
      },
      grid: {
        row: {
          colors: ['#f3f3f3', 'transparent'],
          opacity: 0.5,
        },
      },
      yaxis: {
        tickAmount: 5,
      },
    };

    var videoEl = document.getElementById('video' + this.randomId);
    var ctx = document.getElementById('canvas').getContext('2d');
    let self = this;
    videoEl.addEventListener('loadedmetadata', function () {
      self.makeHeatMapDatas();
      self.caluculateAverageTime(videoEl.duration);
      this.chartOptions = {
        chart: {
          toolbar: {
            show: true,
            tools: {
              download: false,
            },
          },
        },
        colors: ['#4dd0e1'],
        plotOptions: {
          bar: {
            columnWidth: '95%',
          },
        },
        xaxis: {
          categories: self.makeLineCategories(videoEl.duration),
          position: 'top',
          labels: {
            offsetY: -18,
          },
          axisBorder: {
            show: false,
          },
          axisTicks: {
            show: false,
          },
          labels: {
            show: false,
          },
        },
        yaxis: {
          min: 0,
          max: 100,
          labels: {
            show: false,
            formatter: function (val) {
              return val + '%';
            },
          },
        },
        dataLabels: {
          enabled: false,
        },
      };
      var series = self.makeLineDatas(
        self.userNames,
        parseInt(videoEl.duration)
      );
      var allViews = self.trackings.length;
      series = series.map((e) => Math.min(parseInt((e * 100) / allViews), 100)); // %表記に変換
      self.lineSeries = [{ name: '視聴率', data: series }];

      videoEl.addEventListener(
        'timeupdate',
        function () {
          var currentTime = Math.round(videoEl.currentTime);
          var w = videoEl.clientWidth;
          var h = videoEl.clientHeight;

          // 名前描画
          ctx.beginPath();
          ctx.clearRect(0, 0, w, h);
          $('#canvas').attr('width', w);
          $('#canvas').attr('height', h);
          var fontSize = 16;
          if (w < 650) {
            fontSize = 10;
          }
          if (self.isShowUserName) {
            for (var userName of self.userNames[currentTime]) {
              ctx.font = fontSize + 'pt Arial';
              ctx.fillStyle = 'rgba(255, 255, 255)';
              ctx.strokeStyle = 'rgba(0, 0, 0)';
              ctx.lineWidth = 3;
              ctx.strokeText(
                userName['name'],
                Math.round((userName['x'] * w) / 360 + w / 2 - 25),
                Math.round((-userName['y'] * h) / 180 + h / 2 - 30)
              );
              ctx.fillText(
                userName['name'],
                Math.round((userName['x'] * w) / 360 + w / 2 - 25),
                Math.round((-userName['y'] * h) / 180 + h / 2 - 30)
              );
            }
          }

          $('.heatmap-canvas').remove();
          var heatmap = h337.create({
            container: document.querySelector('.heatmap'),
            radius: Math.max(w / 27, 30),
          });

          if (self.heatmapDatas[currentTime]) {
            var heatmapData = self.heatmapDatas[currentTime].map(function (
              value
            ) {
              return {
                x: Math.round((value['x'] * w) / 360 + w / 2),
                y: Math.round((-value['y'] * h) / 180 + h / 2),
                value: value['value'],
              };
            });

            var data = {
              max: 1.1,
              data: heatmapData,
            };
            heatmap.setData(data);
          }
        },
        true
      );
    });
  },
  methods: {
    // 平均再生時間算出
    caluculateAverageTime: function (duration) {
      var totalTime = 0;
      for (var tracking of this.trackings) {
        totalTime += tracking.positions.split('|').length;
      }
      totalTime = parseInt(totalTime / this.trackings.length);
      var minuites = parseInt(totalTime / 60);
      var seconds = ('0' + (totalTime % 60)).slice(-2);
      this.averageTime = minuites + ':' + seconds;
      this.$parent.$parent.$parent.averageTime = minuites + ':' + seconds;
      this.$parent.$parent.$parent.averageTimeRate = Math.round(
        (totalTime * 100) / duration
      );
    },
    makeLineCategories: function (duration) {
      var categories = [];
      for (var i = 0; i <= duration; i++) {
        var minuites = parseInt(i / 60);
        var seconds = ('0' + (i % 60)).slice(-2);
        categories.push(minuites + ':' + seconds);
      }
      return categories;
    },
    makeLineDatas: function (userNames, duration) {
      var series = [];
      for (var i = 0; i <= duration; i++) {
        if (userNames[i]) {
          var ids = userNames[i].map((e) => e.id);
          var uniqIds = Array.from(new Set(ids)); // 重複を削除
          series.push(uniqIds.length);
        } else {
          series.push(0);
        }
      }
      return series;
    },
    getUserName: function (userUUID) {
      var user = this.users.filter((e) => e.uuid == userUUID);
      return user.length > 0 ? user[0].name : 'Unknown User';
    },
    makeHeatMapDatas: function () {
      this.heatmapDatas = [];
      this.userNames = [];
      for (var i = 0; i < this.trackings.length; i++) {
        var positions = this.trackings[i]['positions'].split('|');
        for (var j = 0; j < positions.length; j++) {
          var time = Math.round(positions[j].split(':')[0]);
          var positionX = Math.round(positions[j].split(':')[1]);
          var positionY = Math.round(positions[j].split(':')[2]);
          if (this.heatmapDatas[time] == undefined) {
            this.heatmapDatas[time] = [];
          }
          if (this.userNames[time] == undefined) {
            this.userNames[time] = [];
          }

          // 重複する座標があるかどうか判定
          if (
            this.heatmapDatas[time].some(
              (e) => e.x == positionX && e.y == positionY
            )
          ) {
            this.heatmapDatas[time].forEach((e) =>
              e.x == positionX && e.y == positionY ? (e.value += 1) : e.value
            );
          } else {
            this.heatmapDatas[time].push({
              x: positionX,
              y: positionY,
              value: 1,
            });
          }
          // ユーザ名描画用
          this.userNames[time].push({
            id: this.trackings[i]['id'],
            x: positionX,
            y: positionY,
            name: this.getUserName(this.trackings[i]['user_uuid']),
          });
        }
      }
    },
  },
};
</script>

<style>
.heatmap-canvas {
  pointer-events: none;
}
.line-chart {
  position: absolute;
  top: -30px;
  left: 0px;
  width: 100%;
}
</style>
